#include "angband.h"
#include "monster-hook.h"


/*!
* @brief X^[NGXg̓Ώۂɐ蓾邩Ԃ / Hook function for quest monsters
* @param r_idx X^[hc
* @return ΏۂɂłȂTRUEԂB
*/
bool mon_hook_quest(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	/* Random quests are in the dungeon */
	if (r_ptr->flags8 & RF8_WILD_ONLY) return FALSE;

	/* No random quests for aquatic monsters */
	if (r_ptr->flags7 & RF7_AQUATIC) return FALSE;

	/* No random quests for multiplying monsters */
	if (r_ptr->flags2 & RF2_MULTIPLY) return FALSE;

	/* No quests to kill friendly monsters */
	if (r_ptr->flags7 & RF7_FRIENDLY) return FALSE;

	return TRUE;
}


/*!
* @brief X^[_Wɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return _WɏoȂTRUEԂ
*/
bool mon_hook_dungeon(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (!(r_ptr->flags8 & RF8_WILD_ONLY))
		return TRUE;
	else
	{
		dungeon_info_type *d_ptr = &d_info[dungeon_type];
		if ((d_ptr->mflags8 & RF8_WILD_MOUNTAIN) &&
			(r_ptr->flags8 & RF8_WILD_MOUNTAIN)) return TRUE;
		return FALSE;
	}
}


/*!
* @brief X^[Cmɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return CmɏoȂTRUEԂ
*/
bool mon_hook_ocean(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (r_ptr->flags8 & RF8_WILD_OCEAN)
		return TRUE;
	else
		return FALSE;
}


/*!
* @brief X^[C݂ɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return C݂ɏoȂTRUEԂ
*/
bool mon_hook_shore(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (r_ptr->flags8 & RF8_WILD_SHORE)
		return TRUE;
	else
		return FALSE;
}


/*!
* @brief X^[rnɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return rnɏoȂTRUEԂ
*/
bool mon_hook_waste(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (r_ptr->flags8 & (RF8_WILD_WASTE | RF8_WILD_ALL))
		return TRUE;
	else
		return FALSE;
}


/*!
* @brief X^[ɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return rnɏoȂTRUEԂ
*/
bool mon_hook_town(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (r_ptr->flags8 & (RF8_WILD_TOWN | RF8_WILD_ALL))
		return TRUE;
	else
		return FALSE;
}


/*!
* @brief X^[Xтɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return XтɏoȂTRUEԂ
*/
bool mon_hook_wood(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (r_ptr->flags8 & (RF8_WILD_WOOD | RF8_WILD_ALL))
		return TRUE;
	else
		return FALSE;
}


/*!
* @brief X^[ΎRɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return ΎRɏoȂTRUEԂ
*/
bool mon_hook_volcano(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (r_ptr->flags8 & RF8_WILD_VOLCANO)
		return TRUE;
	else
		return FALSE;
}

/*!
* @brief X^[Rnɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return RnɏoȂTRUEԂ
*/
bool mon_hook_mountain(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (r_ptr->flags8 & RF8_WILD_MOUNTAIN)
		return TRUE;
	else
		return FALSE;
}


/*!
* @brief X^[ɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return XтɏoȂTRUEԂ
*/
bool mon_hook_grass(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (r_ptr->flags8 & (RF8_WILD_GRASS | RF8_WILD_ALL))
		return TRUE;
	else
		return FALSE;
}

/*!
* @brief X^[[n`ɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return [n`ɏoȂTRUEԂ
*/
bool mon_hook_deep_water(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (!mon_hook_dungeon(r_idx)) return FALSE;

	if (r_ptr->flags7 & RF7_AQUATIC)
		return TRUE;
	else
		return FALSE;
}


/*!
* @brief X^[󂢐n`ɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return 󂢐n`ɏoȂTRUEԂ
*/
bool mon_hook_shallow_water(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (!mon_hook_dungeon(r_idx)) return FALSE;

	if (r_ptr->flags2 & RF2_AURA_FIRE)
		return FALSE;
	else
		return TRUE;
}


/*!
* @brief X^[nn`ɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return nn`ɏoȂTRUEԂ
*/
bool mon_hook_lava(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (!mon_hook_dungeon(r_idx)) return FALSE;

	if (((r_ptr->flagsr & RFR_EFF_IM_FIRE_MASK) ||
		(r_ptr->flags7 & RF7_CAN_FLY)) &&
		!(r_ptr->flags3 & RF3_AURA_COLD))
		return TRUE;
	else
		return FALSE;
}


/*!
* @brief X^[ʏ̏n`ɏo邩ǂԂ
* @param r_idx 肷郂X^[̎푰ID
* @return ʏ̏n`ɏoȂTRUEԂ
*/
bool mon_hook_floor(MONRACE_IDX r_idx)
{
	monster_race *r_ptr = &r_info[r_idx];

	if (!(r_ptr->flags7 & RF7_AQUATIC) ||
		(r_ptr->flags7 & RF7_CAN_FLY))
		return TRUE;
	else
		return FALSE;
}
